function uh = Cycle(h,uh,fh,L,n1,n2)
%
%INPUT
%   h = stepsize
%   uh = approximation from finer grid
%   fh = function for RHS on finer grid
%   n1 = Number of iterations of pre-smoothing
%   n2 = Number of iterations of post-smoothing
%
%OUTPUT
%   uh = approxmation after recursion 
%
%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%  Initializations and reformation of A on the coarse grid
%
  n=1/h-1;
  e=ones(n,1);
  Ah=1/h*spdiags([-e 2*e -e], [-1 0 1], n,n);
  bh=h*fh;
%
%  Pre-smoothing
% 
  for k = 1:n1
    uh = Rich(uh,bh,Ah);
    %uh = Jacobi(uh,bh,Ah);
    %uh = SymmGS(uh,bh,Ah);
  end
  if L > 1
    rh = bh - Ah*uh;
    I_r = Restrict(rh / h); 
%    
%  Coarse grid correction. residual for AH*eH = I_r
%    
    L=L-1;
    H = 2*h;
    eH = zeros(size(I_r));
%     figure
%     plot(rh)
    eH = Cycle(H,eH,I_r,L,n1,n2);

%
%  Transfer error to fine grid and update approximation
%
uh = uh + Interp(eH);
  end
%
%  Post-smoothing
%
    for k=1:n2
        uh = Rich(uh,bh,Ah);
        %uh = Jacobi(uh,bh,Ah);
        %uh = SymmGS(uh,bh,Ah);
    end
end