function [x,u,A,h,b] = Init(n,u,f)
%
%INPUT
%   n = number of paritions for [0,1] 
%   u = guess parameter
%   f = function for RHS
%
%OUTPUT
%   x = Partition points of [0,1]
%   u = Random guess
%   A = Stiffness matrix for 1D LaPlacian
%   h = stepsize
%   b = RHS for Possions equation
%
%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
h=1/n;
x=0:h:1; x=x';
b=h*f(x(2:n));
e = ones(n-1,1);
A = 1/h*spdiags([-e 2*e -e], -1:1, n-1, n-1);
%A(1,1)=1; A(n+1,n+1)=1; 
%A(1,2)=0; A(2,1)=0;
%A(n+1,n)=0; A(n,n+1)=0;
    if (u==0)
        u=zeros(0,n-1,1);
    elseif (u==1)
        u=2*rand(n-1,1)-1;
    elseif (u==2)
        u=20*rand(n-1,1)-10;
    elseif (u==3)
        u=200*rand(n-1,1)-100;
    else
    end 
%u(1,1) = 0;u(n+1,1)=0;
end

