function [x,sol,uPlot,err] = MultiGrid(u,L,n,itmax,n1,n2,f)
%
%INPUT
%   u = guess parameter
%   L = exponent of partition
%   n = number of paritions for [0,1] 
%   itmax = number of iterations of V cycle MG
%   n1 = Number of iterations of pre-smoothing
%   n2 = Number of iterations of post-smoothing
%   f = function for RHS
%
%OUTPUT
%   x = partition of interval
%   sol = numerical solution
%   uPlot = approxmation after recursion
%   err = error data
%
%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[x,u,A,h,b]=Init(n,u,f);
sol = A\b;
fh=f(x(2:n));
err = zeros(1,itmax+1);
err(1) = norm(b-A*u)/norm(b);
%
%   Store for plot data
%
uPlot = zeros(n-1,itmax);
uPlot(:,1)=u;
  for k = 1:itmax
    u=Cycle(h,u,fh,L,n1,n2);
    uPlot(:,k+1) = u;
    err(k+1) = norm(b-A*u)/norm(b);
  end
end