function PlotData(x,sol,u,itmax,err)
%
%INPUT
%   x = partition
%   sol = numerical solution
%   u = approximation
%   itmax = number of cycles
%
%OUTPUT
%   Plot data
%
%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ColorL = ['b';'g'; 'r'];
a=repmat(ColorL,itmax/3,1);
for k=1:itmax
    figure(1)    
    plot(x,[0;sol;0] - [0;u(:,k);0],'color',a(k)); 
    title('u_{sol} - u_{approx}')
    pause(.5)
end
%
%   Plot of numerical and approximation
%
  for k=1:itmax
    figure(2)
    plot(x,[0;sol;0],'--','color', 'b')
    hold on
    plot(x,[0;u(:,k);0],'-','color','r')
    hold off
%   legend('Numerical','Approx')
  end
 Title('Numerical Solution VS Approximation')
 hold on
 plot(x,[0;u(:,1);0],'-','color','g')
     legend('Numerical','Approx','Initial Guess')
 hold off
%
%   Initialize and plot l_2 Norm VS cycle count
%
   index = 0:itmax; index=index';
   figure(3)
   subplot(1,2,1)
   semilogy(index,err,'o-')
   xlabel('Cycle number')
   title('l_2 Norm VS cycle count')
   Sup = zeros(1,itmax+1);
   for k = 1:(itmax+1)
     Sup(k) = norm(sol- u(:,k),'inf');
   end
   subplot(1,2,2)
   semilogy(index,Sup,'o-')
   xlabel('Cycle number')
   title('l_{\infty} error VS cycle count')
   hold off
   for k = 1:(itmax+1)
       hold on
       figure(4)
       if k ~= 1
           plot([0;u(:,k);0],'color',a(k-1));
       end
   end
   hold off
end

