close all
clear all
%
%Initialize and set parameters
%   itmax = number of multigrid cycles, make divisible by 3
%   n1 = number of pre-smoothing iterations
%   n3 = number of post-smoothing iterations
%   L = exponent for partition size (for fine to coarse grid)
%   n = number of partitions
%   u = initial guess, 
%       0 assigns zero vector,
%       1 assigns random vector between [-1,1]
%       2 assigns random vector between [-10,10]
%       3 assigns random vector between [-100,100]
%   f = function for RHS of Possions equation
%
%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
itmax=9; n1=2; n2=2;
L=7; n=2^L; u=1;
f = @(x) 4*pi^2*(sin(2*pi*x));
[x,sol,uPlot,err] = MultiGrid(u,L,n,itmax,n1,n2,f);
PlotData(x,sol,uPlot,itmax,err)